/*
 *
 * qsort: esercizio 2
 *
 * Ordinamento di stringhe con qsort()
 */

#include <stdio.h>
#include <stdlib.h>

#define MAXLEN 1000

char **leggi(int *N)
{
    int i;
    char **stringhe;

    scanf("%d", N); /* Numero di stringhe */

    stringhe = (char **)malloc(sizeof (char *) * (*N));
    for ( i = 0; i < *N; i++ ) 
    {
      stringhe[i] = (char *)malloc(sizeof(char)*(MAXLEN+1)); 
      scanf("%s", stringhe[i]);
    }

    return stringhe;
}


/* Confrontatore: ritorna -1, 0, 1 se s1 <, =, > s2  secondo
 * il mio ordinamento */
int confrStringhe( const void *s1, const void *s2 ) 
{
   
   
   /* I due parametri sono dei puntatori ai valori dell'array,
    * ovvero 2 puntatori a stringhe: char **. Prima li 
    * "interpretiamo" con un cast a puntatori a stringhe,
    * poi li dereferenziamo per ottenere l'effettiva stringa. */
   char *stringa1 = *(char **)s1;
   char *stringa2 = *(char **)s2;
   int i;

   /* Confronto alfabetico tra due stringhe. 
    * Se una stringa e' prefisso dell'altra, essa e' minore.
    * Supponendo non siano ne' identiche ne' prefisso, 
    * allora il primo carattere discordante determina l'ordinamento.
    * La procedura sotto è equivalente ad una chiamata alla funzione
    *   strcmp(stringa1, stringa2);
    */

    
    for (i=0;
         stringa1[i] == stringa2[i] && stringa1[i] != '\0'; 
        i++);

    if ( stringa1[i] < stringa2[i] ) 
	return -1;
    else if ( stringa1[i] == stringa2[i] /* == '\0' */)   
	return 0;
    else return 1;
}

int main()
{
   int i;
   int N; /* Numero di stringhe */
   char **stringhe = leggi(&N);

   /* qsort( array, numero_elem, dim_elem, confrontatore) */
   qsort( stringhe, N, sizeof(char*), confrStringhe);

   for ( i = 0; i < N; i++ ) 
     printf("%s\n", stringhe[i]);
   
   return 0;
}

